(*******************************************************************************
**
**  TDisplaySwitcher 1.10
**  copyright  LogicX Software & Grafix Development 2000
**
**  Programming by: Markus Thielen [markus@logicx.de]
**
**  Comments/questions/bugs? Please write me...
**
**  Released as copyrighted freeware.
**
**  Disclaimer:
**  LOGICX SOFTWARE TAKES NO RESPONSIBILITY FOR ANYTHING
**  HARMED OR DAMAGED BY THIS PIECE OF CODE. IF YOU MODIFY
**  IT, THE AUTHOR KEEPS THE RIGHT TO BE SENT A COPY OF
**  THE MODIFIED SOURCE. YOU CAN FREELY MODIFY AND REDISTRIBUTE
**  FOR NON-PROFIT AS LONG AS THE AUTHOR IS MENTIONED.
**  ALL OTHER RIGHTS RESERVED.
**
**  If you add some interesting things to the component please write an email!
**
**  Visit our Homepage at www.logicx.de
**  eMail us at info@logix.de
**
*******************************************************************************)

unit DisplaySwitcher;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TDisplaySwitcher = class(TComponent)
  private
    fcurrwidth: integer;
    fcurrheight: integer;
    { Private-Deklarationen }
    procedure SetNothingint(I:integer);
  protected
    { Protected-Deklarationen }
  public
    constructor Create(AOwner: TComponent); override;
    { Public-Deklarationen }
  published
    procedure SetDisplaySettings(Width,Height,BitsPerPixel:integer; Refresh:BOOL);
    property CurrentWidth:integer read fcurrwidth write setnothingint;
    property CurrentHeight:integer read fcurrheight write setnothingint;
    { Published-Deklarationen }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('LogicX MegaKomponenten', [TDisplaySwitcher]);
end;

function DynamicResolution(X, Y, res: word; udm:BOOL): BOOL;
var
  lpDevMode: TDeviceMode;
begin
  Result := EnumDisplaySettings(nil, 0, lpDevMode);
  if Result then
  begin
    lpDevMode.dmFields := DM_PELSWIDTH Or DM_PELSHEIGHT Or DM_BITSPERPEL;
    lpDevMode.dmPelsWidth := X;
    lpDevMode.dmPelsHeight := Y;
    lpDevMode.dmBitsPerPel := res;
    if udm then
        Result := ChangeDisplaySettings(lpDevMode, CDS_UPDATEREGISTRY) = DISP_CHANGE_SUCCESSFUL
      else
        Result := ChangeDisplaySettings(lpDevMode, 0) = DISP_CHANGE_SUCCESSFUL;
  end;
end;

constructor TDisplaySwitcher.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fcurrwidth := screen.width;
  fcurrheight := screen.height;
end;

procedure TDisplaySwitcher.SetDisplaySettings(Width, Height, BitsPerPixel:integer;Refresh:BOOL);
begin
  if DynamicResolution(width, height, bitsperpixel,refresh) then
    begin
      fcurrwidth := screen.width;
      fcurrheight := screen.height;
    end;
end;

procedure TDisplaySwitcher.SetNothingint(I:integer);
begin
{nothing}
end;
end.
 